scala.tools.nsc.ast.Trees

# InjectDerivedValue

###
Related Doc: package Trees

#### case class InjectDerivedValue(arg: Global.Tree) extends Global.SymTree with Global.TermTree with Product with Serializable

Derived value class injection (equivalent to: `new C(arg)` after erasure); only used during erasure. The class `C` is stored as a tree attachment.

Source
  Trees.scala

Linear Supertypes
Serializable, java.io.Serializable, Global.TermTree, Global.TermTreeApi, Global.SymTree, Global.SymTreeApi, Global.Tree, Global.Attachable, Global.TreeContextApiImpl, Global.TreeApi, Product, Equals, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. InjectDerivedValue
2. Serializable
3. Serializable
4. TermTree
5. TermTreeApi
6. SymTree
7. SymTreeApi
8. Tree
9. Attachable
10. TreeContextApiImpl
11. TreeApi
12. Product
13. Equals
14. AnyRef
15. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new InjectDerivedValue(arg: Global.Tree)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Global.InjectDerivedValue to any2stringadd[Global.InjectDerivedValue] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Global.InjectDerivedValue, B)

   Implicit information
     This member is added by an implicit conversion from Global.InjectDerivedValue to ArrowAssoc[Global.InjectDerivedValue] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val arg: Global.Tree

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def attachments: Attachments { type Pos = Trees.this.Position }

   Definition Classes
     Attachable

9. #### def canHaveAttrs: Boolean

   Definition Classes
     Tree → TreeApi

10. #### def changeOwner(pairs: (Global.Symbol, Global.Symbol)*): Global.Tree

    Definition Classes
      TreeContextApiImpl

11. #### def children: List[Global.Tree]

    Definition Classes
      TreeContextApiImpl → TreeApi

12. #### def clearType(): InjectDerivedValue.this.type

    Definition Classes
      Tree

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### def collect[T](pf: PartialFunction[Global.Tree, T]): List[T]

    Definition Classes
      TreeContextApiImpl → TreeApi

15. #### def correspondsStructure(that: Global.Tree)(f: (Global.Tree, Global.Tree) ⇒ Boolean): Boolean

    Definition Classes
      TreeContextApiImpl

16. #### def defineType(tp: Global.Type): InjectDerivedValue.this.type

    Definition Classes
      Tree

17. #### def duplicate: InjectDerivedValue.this.type

    Definition Classes
      Tree → TreeApi

18. #### def ensuring(cond: (Global.InjectDerivedValue) ⇒ Boolean, msg: ⇒ Any): Global.InjectDerivedValue

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to Ensuring[Global.InjectDerivedValue] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (Global.InjectDerivedValue) ⇒ Boolean): Global.InjectDerivedValue

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to Ensuring[Global.InjectDerivedValue] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): Global.InjectDerivedValue

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to Ensuring[Global.InjectDerivedValue] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): Global.InjectDerivedValue

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to Ensuring[Global.InjectDerivedValue] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(that: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    that

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Tree → Equals → AnyRef → Any

24. #### def equalsStructure(that: Global.Tree): Boolean

    Definition Classes
      TreeContextApiImpl → TreeApi

25. #### def exists(p: (Global.Tree) ⇒ Boolean): Boolean

    Definition Classes
      TreeContextApiImpl → TreeApi

26. #### def filter(f: (Global.Tree) ⇒ Boolean): List[Global.Tree]

    Definition Classes
      TreeContextApiImpl → TreeApi

27. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

28. #### def find(p: (Global.Tree) ⇒ Boolean): Option[Global.Tree]

    Definition Classes
      TreeContextApiImpl → TreeApi

29. #### def forAll(p: (Global.Tree) ⇒ Boolean): Boolean

    Definition Classes
      TreeContextApiImpl → TreeApi

30. #### def foreach(f: (Global.Tree) ⇒ Unit): Unit

    Definition Classes
      TreeContextApiImpl → TreeApi

31. #### def foreachPartial(pf: PartialFunction[Global.Tree, Global.Tree]): Unit

    Definition Classes
      TreeContextApiImpl

32. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to StringFormat[Global.InjectDerivedValue] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

33. #### def freeTerms: List[Global.FreeTermSymbol]

    Definition Classes
      TreeContextApiImpl

34. #### def freeTypes: List[Global.FreeTypeSymbol]

    Definition Classes
      TreeContextApiImpl

35. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

36. #### def hasAttachment[T](implicit arg0: ClassTag[T]): Boolean

    Definition Classes
      Attachable

37. #### def hasExistingSymbol: Boolean

    Definition Classes
      TreeContextApiImpl

38. #### def hasSymbolField: Boolean

    Definition Classes
      SymTree → Tree

39. #### def hasSymbolWhich(f: (Global.Symbol) ⇒ Boolean): Boolean

    Definition Classes
      TreeContextApiImpl

40. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      Tree → AnyRef → Any

41. #### val id: Int

    Definition Classes
      Tree

42. #### def isDef: Boolean

    Definition Classes
      Tree → TreeApi

43. #### def isEmpty: Boolean

    Definition Classes
      Tree → TreeApi

44. #### def isErroneous: Boolean

    Definition Classes
      TreeContextApiImpl

45. #### def isErrorTyped: Boolean

    Definition Classes
      TreeContextApiImpl

46. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

47. #### def isTerm: Boolean

    Definition Classes
      Tree → TreeApi

48. #### def isType: Boolean

    Definition Classes
      Tree → TreeApi

49. #### def isTyped: Boolean

    Definition Classes
      TreeContextApiImpl

50. #### def modifyType(f: (Global.Type) ⇒ Global.Type): Global.Tree

    Definition Classes
      TreeContextApiImpl

51. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

52. #### def nonEmpty: Boolean

    Definition Classes
      Tree → TreeApi

53. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

54. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

55. #### def orElse(alt: ⇒ Global.Tree): Global.Tree

    Definition Classes
      TreeContextApiImpl → TreeApi

56. #### final def pos: Global.Position

    Definition Classes
      Tree → Attachable → TreeApi

57. #### def pos_=(pos: Global.Position): Unit

    Definition Classes
      Attachable

58. #### var rawatt: Attachments { type Pos = Trees.this.Position }

    Attributes
      protected
    Definition Classes
      Attachable

59. #### def removeAttachment[T](implicit arg0: ClassTag[T]): InjectDerivedValue.this.type

    Definition Classes
      Attachable

60. #### def setAttachments(attachments: Attachments { type Pos = Trees.this.Position }): InjectDerivedValue.this.type

    Definition Classes
      Attachable

61. #### def setPos(newpos: Global.Position): InjectDerivedValue.this.type

    Definition Classes
      Attachable

62. #### def setSymbol(sym: Global.Symbol): InjectDerivedValue.this.type

    Definition Classes
      Tree

63. #### def setType(tp: Global.Type): InjectDerivedValue.this.type

    Definition Classes
      Tree

64. #### def shallowDuplicate: Global.Tree

    Definition Classes
      TreeContextApiImpl

65. #### def shortClass: String

    Definition Classes
      TreeContextApiImpl

66. #### def substituteSymbols(from: List[Global.Symbol], to: List[Global.Symbol]): Global.Tree

    Definition Classes
      TreeContextApiImpl

67. #### def substituteThis(clazz: Global.Symbol, to: Global.Tree): Global.Tree

    Definition Classes
      TreeContextApiImpl

68. #### def substituteTypes(from: List[Global.Symbol], to: List[Global.Type]): Global.Tree

    Definition Classes
      TreeContextApiImpl

69. #### def summaryString: String

    Definition Classes
      TreeContextApiImpl

70. #### var symbol: Global.Symbol

    Definition Classes
      SymTree → SymTreeApi → Tree → TreeApi

71. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

72. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      TreeApi → AnyRef → Any

73. #### final def tpe: Global.Type

    Definition Classes
      Tree → TreeApi

74. #### def updateAttachment[T](attachment: T)(implicit arg0: ClassTag[T]): InjectDerivedValue.this.type

    Definition Classes
      Attachable

75. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

76. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

77. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

78. #### def withFilter(f: (Global.Tree) ⇒ Boolean): List[Global.Tree]

    Definition Classes
      TreeContextApiImpl → TreeApi

79. #### def →[B](y: B): (Global.InjectDerivedValue, B)

    Implicit information
      This member is added by an implicit conversion from Global.InjectDerivedValue to ArrowAssoc[Global.InjectDerivedValue] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def hasSymbol: Boolean

   Definition Classes
     Tree
   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use hasSymbolField

2. #### def tpe_=(t: Global.Type): Unit

   Definition Classes
     Tree
   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use setType

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Global.TermTree

### Inherited from Global.TermTreeApi

### Inherited from Global.SymTree

### Inherited from Global.SymTreeApi

### Inherited from Global.Tree

### Inherited from Global.Attachable

### Inherited from Global.TreeContextApiImpl

### Inherited from Global.TreeApi

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Global.InjectDerivedValue to any2stringadd[Global.InjectDerivedValue]

### Inherited by implicit conversion StringFormat from Global.InjectDerivedValue to StringFormat[Global.InjectDerivedValue]

### Inherited by implicit conversion Ensuring from Global.InjectDerivedValue to Ensuring[Global.InjectDerivedValue]

### Inherited by implicit conversion ArrowAssoc from Global.InjectDerivedValue to ArrowAssoc[Global.InjectDerivedValue]

### Ungrouped